/***
*
*	Copyright (c) 2005-2006, AntiHax.Net. All rights reserved.
*	
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted. All use, distribution, or modification is prohibited
*   without donating a cash amount. Visit http://antihax.net/AntiHax:Site_support  (ok really it is free =P).
*
*	Author: "Danni" Wilson
*
****/

#include "plugin.h"	
#include <time.h>
#include "cvar_checks.h"
#include <set>

typedef std::set<int> SET_INT;
typedef std::set<const char*, compare> SET_CHARPTR;

std::set<int> cvarRequests;
std::set<const char*, compare> consistancyExceptions;

void addConsistancyException (const char* file)
{
	SET_CHARPTR::const_iterator it = consistancyExceptions.find(file);
	if (it != NULL && it != consistancyExceptions.end() ) 
		return;

	const char* nfile = strdup(file);
	consistancyExceptions.insert(nfile);
}

int Precache(char *s)
{
	if (!cvar_e_forceintegrity->value == 1)
		RETURN_META_VALUE(MRES_IGNORED, 0);

	SET_CHARPTR::const_iterator it = consistancyExceptions.find(s);
	if (it != NULL && it != consistancyExceptions.end() ) 
	{	
		RETURN_META_VALUE(MRES_IGNORED, 0);
	}

	char dir[1024];
	char game_dir[1024];
	GET_GAME_DIR(game_dir);
	snprintf(dir, 1024, "%s/%s",game_dir, s);

	FILE* fp = fopen(dir,"r");
	if ( fp != NULL) 
	{
		fclose(fp);
		ENGINE_FORCE_UNMODIFIED(force_exactfile,0,0,s);
	}

	RETURN_META_VALUE(MRES_IGNORED, 0);
}

int	InconsistentFile(const struct edict_s *player, const char *filename, char *disconnect_message )
{
	cl_printf(NULL, HUD_PRINTTALK, "(%s) - %s has inconsistant %s. Removing player.", STRING(player->v.netname), GETPLAYERAUTHID((edict_t *)player), filename);
	return 1;
}

void C_CvarValue2(const edict_t *pEdict, int requestId, const char *cvar, const char *value)
{
	SET_INT::iterator it = cvarRequests.find(requestId);
	if (it != cvarRequests.end() && it != NULL)
	{
		cvarRequests.erase(it);
		gotQueryCvarReturn(pEdict, requestId, cvar, value);
		RETURN_META(MRES_HANDLED);
	}

	RETURN_META(MRES_IGNORED);
}

float lasttic = 0.0f;

// Called on map change and server shutdown
void ServerDeactivate(void)
{
	lasttic = 0.0f;
	if (!(cvar_e_logging->value >= 1) || !playerHistory.size())
		return;
	char dir[1024];
	char game_dir[1024];
	char ntime[1024];	

    time_t rawtime;
    struct tm * timeinfo;
 
    time ( &rawtime );
    timeinfo = localtime ( &rawtime );

	strftime(ntime,100,"%y%m%d%H%M", timeinfo);

	GET_GAME_DIR(game_dir);
	snprintf(dir, 1024, "%s/enforcerlogs",game_dir);
	mkdir(dir);
	
	snprintf(dir, 1024, "%s/enforcerlogs/%s.log",game_dir,ntime);
	FILE *logger = fopen(dir,"a");
	fprintf(logger, "*******************************************************************************\n");
	fprintf(logger, "   Rate Enforcer Log for %s\n\n   Thank you for using Rate Enforcer.\n   Please consider donating a small amount so i can\n   continue making such nice products. Visit http://antihax.net/AntiHax:Site_support\n\n", asctime(timeinfo));
	fprintf(logger, "   Server Config Hash is: %s\n", configHash());
	fprintf(logger, "*******************************************************************************\n\n\n");
	
	// Ugly but required to delete elements.
	std::list<eplayer_t*>::iterator p_it = playerHistory.begin();
	while (p_it != playerHistory.end())
	{
		std::list<eplayer_t*>::iterator p_next = p_it;
		++p_next;
		eplayer_t *p = (*p_it);

		fprintf(logger, "Player: %s    SteamID: %s\n=================================================\n\n", p->name, p->steamid);
		
		std::multimap<char*, char*, compare>::iterator c_it = p->cvars.begin();
		while (c_it != p->cvars.end())
		{
			std::multimap<char*, char*, compare>::iterator c_next = c_it;
			++c_next;
			fprintf(logger, "%s \"%s\"\n", (*c_it).first, (*c_it).second);
			p->cvars.erase(c_it);
			c_it = c_next;
		}
		fprintf(logger, "END %s\n\n", p->name);
		free(p->name);
		free(p->steamid);
		delete(*p_it);
		playerHistory.erase(p_it);
		p_it = p_next;
	}
	fclose(logger);

	RETURN_META(MRES_IGNORED);
}

void ClientPutInServer(edict_t *pEntity)
{
	clearPlayer(pEntity);
}

void StartFrame( void ) 
{
	if (gpGlobals->time - lasttic > cvar_e_ticrate->value)
	{
		lasttic = gpGlobals->time;
		DoTick();
	}
	RETURN_META(MRES_IGNORED);
}




