/***
*
*	Copyright (c) 2005-2006, AntiHax.Net. All rights reserved.
*	
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted. All use, distribution, or modification is prohibited
*   without donating a cash amount. Visit http://antihax.net/AntiHax:Site_support  (ok really it is free =P).
*
*	Author: "Danni" Wilson
*
****/


#include "plugin.h"
#include "studio.h"


DLL_GLOBAL const Vector     g_vecZero = Vector(0,0,0);

int m_spriteTexture;


//=========================================================
// UTIL_LogPrintf - Prints a logged message to console.
// Preceded by LOG: ( timestamp ) < message >
//=========================================================
void UTIL_LogPrintf( char *fmt, ... )
{
	va_list			argptr;
	static char		string[1024];
	
	va_start ( argptr, fmt );
	vsprintf ( string, fmt, argptr );
	va_end   ( argptr );

	// Print to server console
	ALERT( at_logged, "%s", string );
}

// Gawd! All these damn util functions to send a message? heh lets do this....
void cl_printf (edict_t *pEntity, int msg_dest, const char *format, ...)
{
	va_list argptr;
	char buf[1028];
	va_start (argptr, format);
	vsnprintf(buf, 1028, format, argptr);
	va_end (argptr);

	/*if (GET_USER_MSG_ID (PLID, "TextMsg", NULL) <= 0)
      REG_USER_MSG ("TextMsg", -1);*/

	if (pEntity) 
		MESSAGE_BEGIN( MSG_ONE, GET_USER_MSG_ID (PLID, "TextMsg", NULL), NULL, pEntity );
	else
		MESSAGE_BEGIN( MSG_ALL, GET_USER_MSG_ID (PLID, "TextMsg", NULL) );

	WRITE_BYTE( msg_dest );
	WRITE_STRING( buf );
	MESSAGE_END();
}

void cl_hudtextf (edict_t *pEntity, const hudtextparms_t &textparms, const char *format, ...)
{
	va_list argptr;
	char buf[512];
	va_start (argptr, format);
	vsnprintf(buf, 512, format, argptr);
	va_end (argptr);
    
	if (pEntity) 
		MESSAGE_BEGIN( MSG_ONE, SVC_TEMPENTITY, NULL, pEntity );
	else
		MESSAGE_BEGIN( MSG_ALL, SVC_TEMPENTITY );

	
		WRITE_BYTE( TE_TEXTMESSAGE );
		WRITE_BYTE( textparms.channel & 0xFF );

		WRITE_SHORT( FixedSigned16( textparms.x, 1<<13 ) );
		WRITE_SHORT( FixedSigned16( textparms.y, 1<<13 ) );
		WRITE_BYTE( textparms.effect );

		WRITE_BYTE( textparms.r1 );
		WRITE_BYTE( textparms.g1 );
		WRITE_BYTE( textparms.b1 );
		WRITE_BYTE( textparms.a1 );

		WRITE_BYTE( textparms.r2 );
		WRITE_BYTE( textparms.g2 );
		WRITE_BYTE( textparms.b2 );
		WRITE_BYTE( textparms.a2 );

		WRITE_SHORT( FixedUnsigned16( textparms.fadeinTime, 1<<8 ) );
		WRITE_SHORT( FixedUnsigned16( textparms.fadeoutTime, 1<<8 ) );
		WRITE_SHORT( FixedUnsigned16( textparms.holdTime, 1<<8 ) );

		if ( textparms.effect == 2 )
			WRITE_SHORT( FixedUnsigned16( textparms.fxTime, 1<<8 ) );
		
		WRITE_STRING( buf );
		
	MESSAGE_END();
}


// _MUCH_ Cleaner :)



bool validPlayer(edict_t *pEdict) {
	if (!pEdict || FNullEnt(pEdict))
		return false;

	int pnum = ENTINDEX(pEdict);

	if ((pEdict->v.flags & FL_CLIENT) && !(pEdict->v.flags & (FL_PROXY|FL_FAKECLIENT))) 
		return true; else return false;
}

void UTIL_SayText( const char *pText, edict_t *pEdict )
{
   if (GET_USER_MSG_ID (PLID, "SayText", NULL) <= 0)
      REG_USER_MSG ("SayText", -1);

   MESSAGE_BEGIN( MSG_ONE, GET_USER_MSG_ID (PLID, "SayText", NULL), NULL, pEdict );
      WRITE_BYTE( ENTINDEX(pEdict) );
      WRITE_STRING( pText );
   MESSAGE_END();
}


unsigned short FixedUnsigned16( float value, float scale )
{
	int output;

	output = (int)(value * scale);
	if ( output < 0 )
		output = 0;
	if ( output > 0xFFFF )
		output = 0xFFFF;

	return (unsigned short)output;
}

short FixedSigned16( float value, float scale )
{
	int output;

	output = (int)(value * scale);

	if ( output > 32767 )
		output = 32767;

	if ( output < -32768 )
		output = -32768;

	return (short)output;
}


bool IsAlive(edict_t *pEdict)
{
   return ((pEdict->v.deadflag == DEAD_NO) &&
           (pEdict->v.health > 0) &&
           !(pEdict->v.flags & FL_NOTARGET) &&
           (pEdict->v.takedamage != 0));
}


//Get mod name
void UTIL_GetModName(char * mod_name, int max_size)
{
	int pos;
	char game_dir[1024];
	
	// find the directory name of the currently running MOD...
	(*g_engfuncs.pfnGetGameDir)(game_dir);
	
	pos = strlen(game_dir) - 1;
	
	// scan backwards till first directory separator...
	while ((pos) && (game_dir[pos] != '/'))
		pos--;
	
	if (pos) pos++;
	
	strncpy(mod_name, &game_dir[pos], max_size);
}





