/***
*
*	Copyright (c) 2005-2006, AntiHax.Net. All rights reserved.
*	
*   Use, distribution, and modification of this source code and/or resulting
*   object code is restricted. All use, distribution, or modification is prohibited
*   without donating a cash amount. Visit http://antihax.net/AntiHax:Site_support  (ok really it is free =P).
*
*	Author: "Danni" Wilson
*
****/

#ifndef _UTILFUNCTIONS_H
#define _UTILFUNCTIONS_H

//======================================================================
// Forward declarations for functions that deal directly with the engine
//======================================================================
#define clamp(x, low, high)  (((x) > (high)) ? (high) : (((x) < (low)) ? (low) : (x)))
#define MakePtr(a,b,c) (c*)(a+b)

#define MAX_TEAMNAME_LENGTH	16
#define MAX_TEAMS			32

#define ABSOLUTE_VALUE_EASY(x) (((x) < 0) ? (-(x)) : (x)) //very useful for gpGlobals->time comparisons

#define WrapAngle(a)    ((a) == 180 ? -180 : \
                        ((a) >= 180 ? (a) - 360 * abs (((int) (a) + 180) / 360) : \
                        ((a) < -180 ? (a) + 360 * abs (((int) (a) - 180) / 360) : \
                        (a))))

#define WrapAngle360(a) ((a) == 360 ? 0 : \
                        ((a) >= 360 ? (a) - 360 * abs ((int) (a) / 360) : \
                        ((a) < 0 ? (a) + 360 * abs (((int) (a) - 360) / 360) : \
                        (a))))
extern bool			validAngle(Vector *vec);
extern bool			validPlayer(edict_t *pEdict);
extern void			UTIL_TraceLine			(const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, edict_t *pentIgnore, TraceResult *ptr);
extern void			UTIL_TraceLine			(const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, IGNORE_GLASS ignoreGlass, edict_t *pentIgnore, TraceResult *ptr);
edict_t				*UTIL_FindEntityInSphere( edict_t *pentStart, const Vector &vecCenter, float flRadius );
extern void			UTIL_TraceHull			(const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, int hullNumber, edict_t *pentIgnore, TraceResult *ptr);

extern bool			UTIL_HitBoxesVisible	(const Vector &vecOrigin, edict_t *pPlayer);
// Modified version from Lasersight MM module.
unsigned int		Unbreakable_Traceline	(const Vector &vecStart, const Vector &vecEnd, edict_t* pIgnore, TraceResult *ptr);
unsigned int		Unbreakable_Tracehull	(const Vector &vecStart, const Vector &vecEnd, const Vector &vecDir, int hullNumber, edict_t *pIgnore, TraceResult *ptr);

extern TraceResult	UTIL_GetGlobalTrace		(void);
extern void			UTIL_TraceModel			(const Vector &vecStart, const Vector &vecEnd, int hullNumber, edict_t *pentModel, TraceResult *ptr);

extern void			UTIL_MakeVectors		(const Vector &vecAngles);
#define				UTIL_EntitiesInPVS(pent)			(*g_engfuncs.pfnEntitiesInPVS)(pent)
extern void			cl_printf (edict_t *pEntity, int msg_dest, const char *format, ...);
extern void			cl_hudtextf (edict_t *pEntity, const hudtextparms_t &textparms, const char *format, ...);
extern void			UTIL_SayText( const char *pText, edict_t *pEdict );
extern bool IsAlive(edict_t *pEdict);
extern bool FVisible( const Vector &vecOrigin, edict_t *pEdict );

Vector GetGunPosition(edict_t *pEdict);


extern int m_spriteTexture;
extern void UTIL_DrawBox (edict_t *pClientEdict, Vector v_bbmin, Vector v_bbmax, int milliseconds, unsigned char red, unsigned char green, unsigned char blue);
extern void UTIL_DrawLine (edict_t *pClientEdict, Vector v_from, Vector v_to, int milliseconds, unsigned char red, unsigned char green, unsigned char blue);
extern void UTIL_DrawBeam (edict_t *pClientEdict, Vector v_from, Vector v_to, int width, int milliseconds, unsigned char red, unsigned char green, unsigned char blue, unsigned char alpha);
extern int  UTIL_GetTeam(edict_t *pEntity);
extern void UTIL_GetModName(char * mod_name, int max_size);

extern void spec_DramaticEvent(int pnum, int tnum);

#endif